/**
 * This file is part of the JustKnit package.
 *
 * @copyright JustKnit (Iris Hammer) <iris@justknit.de>
 * @license All rights reserved (@https://dejure.org/gesetze/UrhG/69a.html)
 * Created on 03-20-2023
 *
 * @package justknit
 */
var v = [], drws = [], sel2 = [], text = '', shps = [], steps = [];
var flds = document.querySelectorAll('.inVal');
var prtBtn = document.querySelector('#prtBtn'), submitBtn = document.querySelector('#submitBtn'), reloadBtn = document.querySelector('#reloadBtn');
var paths = document.getElementById('sketch').querySelectorAll("#cut_sketch_path > path, #arm_sketch_path > path");
var dimGprs = document.getElementById('sketch').querySelectorAll("#cut_sketch  g, #sleeve_sketch  g");
var sketchActive = ['wBust','hProject','wNeck','hNeckBack','neckRoundBack','Sleeve','cut_sketch_path'];
//'hCo2Armhole','hArmhole','wUpperarm','wWrist',
var shapeCut = document.querySelector('#cut').value, shapeArm = document.querySelector('#arm').value, shapeNeck = document.querySelector('#neck').value,shapeShoulder = document.querySelector('#shoulder').value,shapeRaglan = document.querySelector('#raglan').value;
var shapeFrontDivided = document.getElementById('front_divided').checked, shapeHasSleeve = document.getElementById('has_sleeve').checked, shapeFrontband = document.getElementById('frontband').checked;
Array.from(document.getElementById('shape').querySelectorAll("input, select, checkbox, textarea")).forEach(function(el) {shps[el.id] = el;});
Array.from(document.querySelectorAll('[id^="step"]')).forEach(function(el) {steps[el.id] = el;});

/** BEGIN Prepare form and fields functions for field manipulation **/
/**
 * addEvent to selects (tab 'shape')
 */
var allSelect = document.querySelectorAll("select");
for(var slct of allSelect) {
  slct.addEventListener('change', function (e) {
    // disable shoulder and sleeve in case of Raglan
    if (this.id == "arm" ){
      if (this.selectedIndex == 4) {
        shps.has_sleeve.checked = true;
        shps.has_sleeve.value = 1;
        shps.has_sleeve.disabled = true;
        shps.shoulder.required = false;
        shps.raglan.required = true;
        document.querySelector('#shoulder_div').classList.add('d-none');
        document.querySelector('#raglan_div').classList.remove('d-none');
      // shapeRaglan == "raglanRow"
      if (shps.raglan.selectedIndex == 1) {
        document.querySelector('#wRaglanLine').classList.add('d-none');
        shps.wRaglanLine_qty.required = false;
      } else {
        document.querySelector('#wRaglanLine').classList.remove('d-none');
        shps.wRaglanLine_qty.required = true;
      }
      // shapeRaglan == "raglanRound"
      if (shps.raglan.selectedIndex == 2) {
        document.getElementById('neckBackShow').hidden = true;
        document.getElementById('neckFrontShow').hidden = true;
        document.getElementById('capSleeveShow').hidden = true;
      } else {
        document.getElementById('neckBackShow').hidden = false;
        document.getElementById('neckFrontShow').hidden = false;
        document.getElementById('capSleeveShow').hidden = false;
      }
      } else {
      shps.shoulder.required = true;
      shps.raglan.required = false;
      document.querySelector('#shoulder_div').classList.remove('d-none');
      document.querySelector('#raglan_div').classList.add('d-none');
      shps.has_sleeve.disabled = false;
      document.querySelector('#wRaglanLine').classList.add('d-none');
      shps.wRaglanLine_qty.required = false;
      }
    }
    if (this.id == "raglan" ) {
      if  (this.selectedIndex == 1) {
        document.querySelector('#wRaglanLine').classList.add('d-none');
        shps.wRaglanLine_qty.required = false;
      } else {
        document.querySelector('#wRaglanLine').classList.remove('d-none');
        shps.wRaglanLine_qty.required = true;
      }
    }
  // update values of shape var
  updateShapeValues()
  });
}
/**
 * addEvent to checkbox (tab 'shape')
 */
var allCheck = document.querySelectorAll('input[type="checkbox"]');
for(var chkb of allCheck) {
  chkb.addEventListener('change', function (e) {
    document.getElementById('frontband').disabled = (this.id == 'front_divided' && this.checked) ? false : true;
    this.value = this.checked ? 1:0;
  // update values of shape
    updateShapeValues();
  });
}
/**
 * addEvent to gauge inputs change for invalid values (tab 'gauge')
 */
var gaugeInputs = document.getElementById('gauge').querySelectorAll("input");
for(var gaugeInput of gaugeInputs) {
  gaugeInput.addEventListener('change', function (e) {
    this.classList.remove('is-invalid');
// gauge width or height must be > 3
    if (this.id.includes('len') && this.value <= 3){
        var divID = document.getElementById('D'+this.id);
        if (divID) {divID.innerHTML = lex["jk.inv_gauge_len"];}
        this.classList.add('is-invalid');
    }
// Value of 0 is not permitted
    if (this.value == 0 || this.value == '') {
      var divID = document.getElementById('D'+this.id);
      if (divID) {divID.innerHTML = lex["jk.inv_0"];}
      this.classList.add('is-invalid');
    }
  })
}
/**
 * addEvent to modal to edit dims in svg (tab 'sketch')
 */
var dimModal = document.getElementById('dim-modal');
dimModal.addEventListener('show.bs.modal', event => {
  const whichDim = event.relatedTarget.getAttribute('data-bs-dim');
  document.querySelector('#dimModalLabel').textContent = lex['pj.dim_' + whichDim + '_modal_title'];
  document.querySelector('#dimLabel').title = lex['pj.dim_' + whichDim + '_label_title'];
  document.querySelector('#dimLabel').textContent = lex['pj.dim_' + whichDim + '_label_text'];
  document.querySelector('#dimLink').title = lex['pj.dim_' + whichDim + '_pop_title'];
  document.querySelector('#dimLink').setAttribute("data-bs-content",lex['pj.dim_' + whichDim + '_pop_content']);
  document.querySelector('#dimLink').setAttribute("data-bs-title",lex['pj.dim_' + whichDim + '_pop_title']);
  document.querySelector('#pe-dim').title = lex['pj.dim_' + whichDim + '_label_title'];
  document.querySelector('#pe-dim').value = document.querySelector('#' + whichDim + '_len').value;
  document.querySelector('#dimLen').textContent = lex['pj.dim_' + whichDim + '_invalid'];
  document.querySelector('#save-modal-dim').onclick = function() { changeDim(whichDim); }
  //document.querySelector('#pe-dim').focus();
});
dimModal.addEventListener('shown.bs.modal', event => {
  document.querySelector('#pe-dim').focus();
});
/**
 * addEvent to progressbar and buttons to Hide and display accordion tabs
 */
/** Shapes **/
var targetShape = document.querySelectorAll('.target-shape');
for (let i = 0; i < targetShape.length; i++) {
  targetShape[i].addEventListener('click', (e) => {
    steps['step2'].classList.remove('active');
    steps['step3'].classList.remove('active');
    steps['step4'].classList.remove('active');
    prtBtn.classList.add('d-none');
  });
}
/** Sketch **/
var targetSketch = document.querySelectorAll('.target-sketch');
for (let i = 0; i < targetSketch.length; i++) {
targetSketch[i].addEventListener('click', (e) => {
  //var test = document.getElementById('shape').querySelectorAll("select");
  var shapesSelect = document.getElementById('shape').querySelectorAll("[required]");
  var showSketch = Array.from(shapesSelect, (shapesSelect) => shapesSelect.value);
  if (showSketch.every(element => element !== "")) {
    document.querySelector('#sketch_div').hidden = false;
    document.querySelector('#sketch_err').hidden = true;
    document.querySelector('#sketch_err').classList.remove('show');
    document.querySelector('#pattern_div').hidden = false;
    document.querySelector('#pattern_err').hidden = true;
    document.querySelector('#pattern_err').classList.remove('show');
  } else {
    document.querySelector('#sketch_div').hidden = true;
    document.querySelector('#sketch_err').hidden = false;
    document.querySelector('#sketch_err').classList.add('show');
    document.querySelector('#gaugeError').innerHTML = (shapeArm == "armRaglan" && shapeRaglan == '') ? lex["pj.shape_err"] + lex["pj.shapeRaglan_err"] : lex["pj.shape_err"];
    document.querySelector('#gaugeError').innerHTML = (shps.raglan.selectedIndex > 1 && (document.getElementById('wRaglanLine_qty').value == 0 || document.getElementById('wRaglanLine_qty').value == '')) ? document.querySelector('#gaugeError').innerHTML + lex["pj.wRaglanLine_err"]  : document.querySelector('#gaugeError').innerHTML;
    document.querySelector('#pattern_div').hidden = true;
    document.querySelector('#pattern_err').hidden = false;
    document.querySelector('#pattern_err').classList.add('show');
  }
  steps['step2'].classList.add('active');
  steps['step3'].classList.remove('active');
  steps['step4'].classList.remove('active');
  // show and hide the paths of svg
  resetSketch();
  displaySketch();
  prtBtn.classList.add('d-none');
});
}
/** Gauge **/
var targetGauge = document.querySelectorAll('.target-gauge');
for (let i = 0; i < targetGauge.length; i++) {
  targetGauge[i].addEventListener('click', (e) => {
  steps['step2'].classList.add('active');
  steps['step3'].classList.add('active');
  steps['step4'].classList.remove('active');
  prtBtn.classList.add('d-none');
  document.getElementById('len_w').focus();
  });
}
/** Pattern **/
var targetPattern = document.querySelectorAll('.target-pattern');
for (let i = 0; i < targetPattern.length; i++) {
  targetPattern[i].addEventListener('click', (e) => {
  resetSketch();
  displaySketch();
  checkDim();
  showPattern();
  steps['step2'].classList.add('active');
  steps['step3'].classList.add('active');
  steps['step4'].classList.add('active');
  });
}
/**
 * Hide and display complete form if no project is selected
 */

if (res.dims == 0) {
  document.getElementById('noProject').hidden = false;
  document.getElementById('prt-' + res.alias).hidden = true;
  document.getElementById('loading').hidden = true;
} else {
  document.getElementById('noProject').hidden = true;
  document.getElementById('prt-' + res.alias).hidden = false;
  document.getElementById('loading').hidden = true;
}
/**
 * addEvent to buttons
 */
/**
 * #submitBtn write Pattern and submit form
 */
submitBtn.addEventListener('click', function (e) {
    success = writePattern();
    var projectForm = document.querySelector('[id^="calc-"]');
    if (success) {
      console.log('Ready!!');
      projectForm.submit();
      prtBtn.remove('d-none');
    } else {
        e.preventDefault()
        e.stopPropagation()
    }
  });
/**
 *  #clrBtn clear all displayed dims
 */
document.getElementById('clrBtn').addEventListener('click', function (e) {
  for (var i = 0; i < res.dims.length; i++){
    document.getElementById(res.dims[i]+'-s').innerHTML = '&#x270E;';
    document.getElementById(res.dims[i]).classList.add('blank');
    document.getElementById(res.dims[i]+'_len').value = 0;
  }
})
/**
 * #reloadBtn reload last saved values
 */
reloadBtn.addEventListener('click', function (e) {
  //window.location.reload(true);
  window.location.hash = 'reloadBtn';
  window.location.reload();
  document.getElementById('sketch').collapse('toggle');
})
/**
 * show last visited accordion tab on reload/submit and set related values
 */
document.addEventListener("DOMContentLoaded", function(e) {
  resetSketch();
  displaySketch();
  if(window.location.hash == "#reloadBtn") {
    const bsCollapse = new bootstrap.Collapse('#sketch', {
      toggle: true
    })
     window.location.hash = '';
    console.log("The Page has been reloaded!");
  } else if (window.location.hash == "#pattern" ) {
    showPattern();
    const bsCollapse = new bootstrap.Collapse('#pattern', {
      toggle: true
    })
    steps['step2'].classList.add('active');
    steps['step3'].classList.add('active');
    steps['step4'].classList.add('active');
    prtBtn.classList.remove('d-none');
    window.location.hash = '';
    console.log("The page has been submited!");
  } else {
    console.log("The page has a new hit!");
  }
  // show default values
  document.getElementById('frontband').disabled = (document.querySelector('#front_divided').checked) ? false : true;
  if (document.querySelector('#arm').selectedIndex == 4) {
    // armRaglan
    document.querySelector('#has_sleeve').checked = true;
    document.querySelector('#has_sleeve').value = 1;
    document.querySelector('#has_sleeve').disabled = true;
    document.querySelector('#shoulder').required = false;
    document.querySelector('#raglan').required = true;
    document.querySelector('#shoulder_div').classList.add('d-none');
    document.querySelector('#raglan_div').classList.remove('d-none');
    // shapeRaglan == "raglanRow"
    if (document.querySelector('#raglan').selectedIndex == 1) {
      document.querySelector('#wRaglanLine').classList.add('d-none');
      document.querySelector('#wRaglanLine_qty').required = false;
    } else {
      document.querySelector('#wRaglanLine').classList.remove('d-none');
      document.querySelector('#wRaglanLine_qty').required = true;
    }
    // shapeRaglan == "raglanRound"
    if (document.querySelector('#raglan').selectedIndex == 2) {
      document.getElementById('neckBackShow').hidden = true;
      document.getElementById('neckFrontShow').hidden = true;
      document.getElementById('capSleeveShow').hidden = true;
    } else {
      document.getElementById('neckBackShow').hidden = false;
      document.getElementById('neckFrontShow').hidden = false;
      document.getElementById('capSleeveShow').hidden = false;
    }
  } else {
    document.querySelector('#shoulder').required = true;
    document.querySelector('#raglan').required = false;
    document.querySelector('#shoulder_div').classList.remove('d-none');
    document.querySelector('#raglan_div').classList.add('d-none');
    document.querySelector('#has_sleeve').disabled = false;
    document.querySelector('#wRaglanLine').classList.add('d-none');
    document.querySelector('#wRaglanLine_qty').required = false;
  }
});
/**
 * check values of dims on leaving accordion #sketch
 */
document.querySelector('#sketch').addEventListener('hide.bs.collapse', function (e) {
  console.log('hide sketch');
  checkDim();
})

/** END field manipulation **/
/** BEGIN helper functions for field manipulation **/
/** update values of Shape variables **/

function updateShapeValues() {
    shapeCut = document.getElementById('cut').value;
    shapeArm = document.getElementById('arm').value;
    shapeNeck = document.getElementById('neck').value;
    shapeShoulder = document.getElementById('shoulder').value;
    shapeRaglan = document.getElementById('raglan').value;
    shapeFrontDivided = document.getElementById('front_divided').checked;
    shapeHasSleeve = document.getElementById('has_sleeve').checked;
    shapeFrontband = document.getElementById('frontband').checked;
}

/** show/hide edit Pattern on pattern tab **/
function setEditPattern(y) {
  if (y) {
    submitBtn.setAttribute('aria-expanded', false);
    document.querySelector('#calculate').classList.remove('show');
    prtBtn.classList.add('d-none');
    submitBtn.classList.remove('d-none');
  } else {
    submitBtn.setAttribute('aria-expanded', true);
    document.querySelector('#calculate').classList.add('show');
    prtBtn.classList.remove('d-none');
    submitBtn.classList.add('d-none');
  }
}
/** Hide all depending paths and dims **/
function resetSketch() {
  paths.forEach(function(el) {el.setAttribute('opacity',0);});
  dimGprs.forEach(function(el) {el.setAttribute('opacity',0);});
  sketchActive.forEach(function(el) {document.getElementById(el).setAttribute('opacity',1) });
  document.getElementById('arm_sketch_path').setAttribute('opacity',0);
  document.getElementById('sleeve_sketch_flds').classList.add('d-none');
  document.getElementById('sleeve_sketch').setAttribute('display','none');
}
/** show all paths and dims depending on selected values of target-shape **/
function displaySketch() {
var shapeCut = document.querySelector('#cut').value, shapeArm = document.querySelector('#arm').value, shapeNeck = document.querySelector('#neck').value,shapeShoulder = document.querySelector('#shoulder').value,shapeRaglan = document.querySelector('#raglan').value;
var shapeFrontband = document.getElementById('frontband').checked;
  // show complete sketch of sleeve
  if (shps.has_sleeve.checked) {
    document.getElementById('arm_sketch_path').setAttribute('opacity',1);
    document.getElementById('sleeve_sketch').setAttribute('display','inherit');
    document.getElementById('sleeve_sketch_flds').classList.remove('d-none');
    document.querySelector('#wUpperarm').setAttribute('opacity',1);
    document.querySelector('#wWrist').setAttribute('opacity',1);
  }
  // show front devided
  var front = ['FrontDivided','wFrontband','wFront'];
  if (shps.front_divided.checked) {
    front.forEach(function(el) {document.getElementById(el).setAttribute('opacity',1)});
  }
  // show path for shoulder depending on value of arm
  switch (shapeArm) {
    case "armEven":
      // Wide
      if (shapeShoulder == "shoulderSlope") {
        document.querySelector('#shoulderSlopeWide').setAttribute('opacity',1);
        document.querySelector('#hShoulder').setAttribute('opacity',1);
      } else {
        document.querySelector('#shoulderEvenWide').setAttribute('opacity',1);
      }
      if (shapeHasSleeve) {
        document.querySelector('#hArmhole').setAttribute('opacity',1);
        document.querySelector('#hCo2Armhole').setAttribute('opacity',1);
      }

      break;
    case "armCap":
    case "armEvenSi":
    case "armSlope":
      // Slim
      if (shapeShoulder == "shoulderSlope") {
        document.querySelector('#shoulderSlopeSlim').setAttribute('opacity',1);
        document.querySelector('#hShoulder').setAttribute('opacity',1);
      } else {
        document.querySelector('#shoulderEvenSlim').setAttribute('opacity',1);
      }
      break;
    case "armRaglan":
      document.querySelector('#hNeckBack').setAttribute('opacity',0);
      break;
    default:
      document.querySelector('#shoulderEvenSlim').setAttribute('opacity',0);
      document.querySelector('#shoulderSlopeSlim').setAttribute('opacity',0);
      document.querySelector('#shoulderSlopeWide').setAttribute('opacity',0);
      document.querySelector('#shoulderEvenWide').setAttribute('opacity',0);
      document.querySelector('#hShoulder').setAttribute('opacity',0);
      break;
  }

  var shape2Sketch = {
    'cut':{
      'cutEven':['cutEven']
      ,'cutWaistshape':['cutWaistshape','wWaist','wHips','hCo2hips','hHips2waist','hWaist2armhole']
      ,'cutAline':['cutAline','wHips','hCo2hips']
      ,'cutSingleshape':['cutSingleshape','wWaist']
    }
    ,'arm':{
      'armCap':['armCap','sleeveCap','wShoulder','wCrossback','wArmhole','hCap','hSleeve','hSleeve2Underarm']
      ,'armEvenSi':['armEvenSi','sleeveEvenSi','wShoulder','wCrossback','wArmhole','hCap','hSleeve','hSleeve2Underarm']
      ,'armSlope':['armSlope','sleeveSlope','wShoulder','wCrossback','wArmhole','hCap','hSleeve','hSleeve2Underarm']
      ,'armRaglan':['armRaglan','sleeveRaglan','wCrossback','hCap','hSleeve','hSleeve2Underarm','wNeckRaglan']
//'wShoulder', 'wArmhole',
      ,'armEven':['armEven','sleeveEven','hSleeve2Underarm']
      ,'armYoke':['armYoke','sleeveYoke','wShoulder','wCrossback','wArmhole','hSleeve2Underarm','wNeckRaglan']
    }
    ,'neck':{
      'neckRound':['neckRound','hNeckFront']
      ,'neckV':['neckV','hNeckFront']
//      ,'neckSquare':{'neckSquare','hNeckFront'}
      ,'neckEven':['neckEven']
    }
  };
  var noSleeve = ['hCap', 'hSleeve', 'hSleeve2Underarm', 'wNeckRaglan', 'wUpperarm', 'wWrist'];
  for (var i of Object.keys(shape2Sketch)) {
    //var sel = document.getElementById(i).value;
    if (document.getElementById(i).value) {
    sel2 = shape2Sketch[i][document.getElementById(i).value];
      for (var j = 0; j < sel2.length; j++){
        document.getElementById(sel2[j]).setAttribute('opacity',1);
      }
    }
  }
  if (!shps.has_sleeve.checked) {
    noSleeve.forEach(function(el) {document.getElementById(el).setAttribute('opacity',0)});
  }
  if (shapeArm !== "armEven") {
    document.querySelector('#hCo2Armhole').setAttribute('opacity',1);
    document.querySelector('#hArmhole').setAttribute('opacity',1);
  }
}
/** show error or calc div on pattern tab **/
function showPattern () {
  var showShapes = Array.from(document.getElementById('shape').querySelectorAll("[required]"), (e) => (e.value == '' ) ? false:true);
  var showDims = Array.from(document.getElementById('sketch').querySelectorAll('g[opacity="1"].dim'),(e) => (document.getElementById(e.id + '_len').value == "0") ? false:true);
  var showGauge = Array.from(document.getElementById('gauge').querySelectorAll("input"),(e) => (e.value == '' || e.value == "0") ? false:true);
  var allSov = Array.from(document.querySelectorAll("[sov]"),(e) => (e.value == e.getAttribute('sov')) ? true: false);
  var dimErr = (document.getElementById('alert_err').innerHTML == '') ? true : false;
  if ((showShapes.every(e => e) && showDims.every(e => e) && showGauge.every(e => e) && dimErr) || window.location.hash == "#pattern" ) {
    document.querySelector('#pattern_div').hidden = false;
    document.querySelector('#pattern_err').hidden = true;
    document.querySelector('#pattern_err').classList.remove('show');
    document.getElementById('raglanRoundShow').hidden = (shapeArm == "armRaglan" && shapeRaglan == "raglanRound") ? false : true;
    allSov.every(e => e) ? setEditPattern(false) : setEditPattern(true);
  } else {
    document.querySelector('#pattern_div').hidden = true;
    document.querySelector('#pattern_err').hidden = false;
    document.querySelector('#pattern_err').classList.add('show');
    document.querySelector('#pattern_err_shape').hidden = showShapes.every(e => e);
    document.querySelector('#pattern_err_sketch').hidden = showDims.every(e => e);
    document.querySelector('#pattern_err_dim').hidden = dimErr;
    document.querySelector('#pattern_err_gauge').hidden = showGauge.every(e => e);
    setEditPattern(false);
  }
  document.getElementById('pattern_sleeve').hidden = (document.getElementById('has_sleeve').checked) ? false : true;
  document.getElementById('shoulderShow').hidden = (shapeArm == "armRaglan") ? true : false;

}
/** fill target dim with value **/
function fillTarget(value,target) {
  document.querySelector('#'+target+'_len').value = value;
  if (value==0 || value == '') {
    document.querySelector('#'+target+'-s').innerHTML = '&#x270E;';
    document.querySelector('#'+target).classList.add('blank');
  } else {
    document.querySelector('#'+target+'-s').innerHTML = value +' cm';
    document.querySelector('#'+target).classList.remove('blank');
    document.querySelector('#'+target).classList.remove('err');
  }
  document.getElementById(target+'_len').value = value;
}
/** edit dims in modal, change dependent values **/
function changeDim(d) {
  var dimVal = parseInt(document.querySelector('#pe-dim').value*2)/2;
  fillTarget(dimVal,d);
  var v = [];
  Array.from(document.querySelectorAll("[id*='_len']")).forEach(function(el) { v[el.id.slice(0, el.id.length-4)] = parseInt(el.value*2)/2; });
  // Autofill Values if Dims
  switch (d) {
    case "wBust":
      if (v['wCrossback'] > 0) {
        fillTarget((dimVal - v['wCrossback'])/2,"wArmhole");
      }
      if (shapeFrontDivided && shapeCut == "cutEven") {
        if (shapeFrontband) {
          fillTarget((dimVal - v['wFrontband']) / 2,"wFront");
        } else {
          fillTarget((dimVal + v['wFrontband']) / 2,"wFront");
        }
      }
      if (shapeArm == "armEven") {
        if (v['wNeck'] > 0) {
          fillTarget((dimVal - v['wNeck']) / 2,"wShoulder");
        }
      }
      break;
    case "wWaist":
      if (shapeFrontDivided && shapeCut == "cutSingleshape") {
        if (shapeFrontband) {
          fillTarget((dimVal - v['wFrontband']) / 2,"wFront");
        } else {
          fillTarget((dimVal + v['wFrontband']) / 2,"wFront");
        }
      }
      break;
    case "wHips":
      if (shapeFrontDivided) {
        if (shapeFrontband) {
          fillTarget((dimVal - v['wFrontband']) / 2,"wFront");
        } else {
          fillTarget((dimVal + v['wFrontband']) / 2,"wFront");
        }
      }
      break;
    case "wFrontband":
      if (shapeCut == "cutSingleshape") {
        var wCast = v['wWaist'];
      } else if (shapeCut == "cutWaistshape" || shapeCut == "cutAline") {
        var wCast = v['wHips'];
      } else { //cutEven
        var wCast = v['wBust'];
      }
        if (shapeFrontband) {
          fillTarget((wCast - dimVal)/2,"wFront");

        } else {
          fillTarget((wCast + dimVal)/2,"wFront");
        }
      break;
    case "wFront":
      // das ist zu kompliziert. Dann müsste geprüft werden, welcher Schnitt und dann ggf noch crossback usw. geändert werden
      break;
    case "hCo2hips":
      if (shapeCut == "cutWaistshape" && v['hHips2waist'] > 0 && v['hWaist2armhole'] > 0) {
        fillTarget(dimVal + v['hHips2waist'] + v['hWaist2armhole'],"hCo2Armhole");
      }
    break;
    case "hHips2waist":
      if (shapeCut == "cutWaistshape" && v['hCo2hips'] > 0 && v['hWaist2armhole'] > 0) {
        fillTarget(dimVal + v['hCo2hips'] + v['hWaist2armhole'],"hCo2Armhole");
      }
    break;
    case "hWaist2armhole":
      if (shapeCut == "cutWaistshape" && v['hCo2hips'] > 0 && v['hHips2waist'] > 0) {
        fillTarget(dimVal + v['hCo2hips'] + v['hHips2waist'],"hCo2Armhole");
      }
    break;
    case "hCo2Armhole":
      if (v['hArmhole'] > 0 ) {
        fillTarget(dimVal + v['hArmhole'],"hProject");
      }
    break;
    case "hProject":
      if (v['hArmhole'] > 0 ) {
        fillTarget(dimVal - v['hArmhole'],"hCo2Armhole");
      }
      break;
    case "hNeckFront":
    break;
    case "hArmhole":
      if (shapeArm == "armEven" || shapeArm == "armEvenSi" || shapeArm == "armSlope") {
        fillTarget(dimVal*2,"wUpperarm");
      }
      if (shapeArm == "armRaglan" ) {
        if (v['wNeckRaglan'] > 0) {
          fillTarget(dimVal - v['wNeckRaglan'] /2,"hCap");
        }
      }
      if (v['hProject'] > 0) {
        fillTarget(v['hProject'] - dimVal,"hCo2Armhole");
      } else if (v['hCo2Armhole'] > 0) {
        fillTarget(v['hCo2Armhole'] + dimVal,"hProject");
      }
      break;
    case "hNeckBack":
    break;
    case "hShoulder":
    break;
    case "wNeck":
      if (v['wCrossback'] > 0 ) {
        fillTarget((v['wCrossback'] - dimVal) / 2,"wShoulder");
      }
      if (shapeArm == "armEven") {
        if (v['wBust'] > 0) {
          fillTarget((v['wBust'] - dimVal) / 2,"wShoulder");
        }
      }
    break;
    case "wShoulder":
      if (v['wCrossback'] > 0 ) {
        fillTarget((v['wCrossback'] - dimVal*2) ,"wNeck");
      }
      break;
    case "wCrossback":
      if (shapeArm !== "armEven") {
        if (v['wBust'] > 0) {
          fillTarget((v['wBust'] - dimVal)/2 ,"wArmhole");
        }
        if (v['wNeck'] > 0) {
          fillTarget((dimVal - v['wNeck'])/2  ,"wShoulder");
        }
      }
      break;
    case "wArmhole":
      if (shapeArm == "armEvenSi" || shapeArm == "armSlope") {
        fillTarget(dimVal ,"hCap");
        if (v['hSleeve2Underarm'] > 0 ) {
          fillTarget(v['hSleeve2Underarm'] + dimVal,"hSleeve");
        } else if (v['hSleeve'] > 0) {
          fillTarget(v['hSleeve'] - dimVal ,"hSleeve2Underarm");
        }
      }
      break;
    case "hCap":
      if (v['hSleeve2Underarm'] > 0 ) {
        fillTarget(v['hSleeve2Underarm'] + dimVal,"hSleeve");
      } else if (v['hSleeve'] > 0) {
        fillTarget(v['hSleeve']  - dimVal,"hSleeve2Underarm");
      }
      break;
    case "hSleeve":
      fillTarget(dimVal - v['hCap'] ,"hSleeve2Underarm");
      break;
    case "hSleeve2Underarm":
      if (v['hCap'] > 0 ) {
        fillTarget(v['hCap'] + dimVal,"hSleeve");
      }
      break;
    case "wNeckRaglan":
      fillTarget(dimVal / 2 ,"hShoulder");
      if (v['hArmhole'] > 0 ){
        fillTarget( v['hArmhole'] - dimVal /2,"hCap");
      }
      break;
    case "wUpperarm":
      if (shapeArm == "armEven" || shapeArm == "armEvenSi" || shapeArm == "armSlope") {
        fillTarget(dimVal/2 ,"hArmhole");
      }
      break;
    case "wWrist":
      break;
    default:
      break;
  }
}
/** check all values of dims and fill error tpl **/
function checkDim() {
  var d = [], errorTpl = [], g = [];
  d.length = document.querySelectorAll("[id*='_len']").length;
  document.querySelectorAll("[id*='_len']").forEach(function(el) { d[el.id.slice(0, el.id.length-4)] = parseInt(el.value*2)/2; });
  g.length = document.getElementById('sketch').querySelectorAll('g.dim').length;
  document.getElementById('sketch').querySelectorAll('g.dim').forEach(function(el) {g[el.id] = parseInt(el.getAttribute("opacity")); });
  if (d['hProject'] !== d['hCo2Armhole'] + d['hArmhole'] && (g['hProject'] && g['hCo2Armhole'] && g['hArmhole']) && (d['hProject'] > 0 && d['hCo2Armhole'] > 0 && d['hArmhole'] > 0)) {
    errorTpl.push(lex['pj.hProject_hArmhole_err']);
    document.getElementById('hProject').classList.add('err');
    document.getElementById('hCo2Armhole').classList.add('err');
    document.getElementById('hArmhole').classList.add('err');
  }
  if (d['wShoulder'] !== (d['wCrossback'] - d['wNeck']) / 2 && (g['wShoulder'] && g['wCrossback'] && g['wNeck']) && (d['wShoulder'] > 0 && d['wCrossback'] > 0 && d['wNeck'] > 0)) {
    errorTpl.push(lex['pj.wCrossback_wShoulder_err']);
    document.getElementById('wShoulder').classList.add('err');
    document.getElementById('wCrossback').classList.add('err');
    document.getElementById('wNeck').classList.add('err');
  }
  if (d['hSleeve'] !== d['hSleeve2Underarm'] + d['hCap'] && (g['hSleeve'] && g['hSleeve2Underarm'] && g['hCap']) && (d['hSleeve'] > 0 && d['hSleeve2Underarm'] > 0 && d['hCap'] > 0)) {
    errorTpl.push(lex['pj.hSleeve_hCap_err']);
    document.getElementById('hSleeve').classList.add('err');
    document.getElementById('hSleeve2Underarm').classList.add('err');
    document.getElementById('hCap').classList.add('err');
  }
  if (d['wBust'] !== d['wCrossback'] + 2 * d['wArmhole'] && ( g['wBust'] && g['wCrossback'] && g['wArmhole']) && (d['wBust'] > 0 && d['wCrossback'] > 0 && d['wArmhole'] > 0)) {
    errorTpl.push(lex['pj.wBust_wCrossback_err']);
    document.getElementById('wBust').classList.add('err');
    document.getElementById('wCrossback').classList.add('err');
    document.getElementById('wArmhole').classList.add('err');
  }
  if (shapeArm == "armEvenSi" || shapeArm == "armSlope") {
    if (d['hCap'] !== d['wArmhole'] && ( g['hCap'] && g['wArmhole']) && (d['hCap'] > 0 && d['wArmhole'] > 0)) {
      errorTpl.push(lex['pj.hCap_wArmhole_err']);
      document.getElementById('hCap').classList.add('err');
      document.getElementById('wArmhole').classList.add('err');
    }
  }
  if (shapeArm == "armEvenSi" || shapeArm == "armSlope" || shapeArm == "armEven") {
    if (d['wUpperarm'] !== d['hArmhole'] * 2 && ( g['wUpperarm'] && g['hArmhole']) && (d['wUpperarm'] > 0 && d['hArmhole'] > 0)) {
      errorTpl.push(lex['pj.wUpperarm_hArmhole_err']);
      document.getElementById('wUpperarm').classList.add('err');
      document.getElementById('hArmhole').classList.add('err');
    }
  }
  if (shapeCut == "cutWaistshape" && d['hCo2Armhole'] !== d['hCo2hips'] + d['hHips2waist'] + d['hWaist2armhole']) {
    errorTpl.push(lex['pj.cutWaistshape_hCo2Armhole_err']);
    document.getElementById('hCo2Armhole').classList.add('err');
    document.getElementById('hCo2hips').classList.add('err');
    document.getElementById('hHips2waist').classList.add('err');
    document.getElementById('hWaist2armhole').classList.add('err');
  }
  if (shapeArm == "armRaglan") {
    if (d['hCap'] !== d['hArmhole'] - d['wNeckRaglan'] / 2 && ( g['hCap'] && g['hArmhole'] && g['wNeckRaglan'])) {
      errorTpl.push(lex['pj.armRaglan_hCap_err']);
      document.getElementById('hCap').classList.add('err');
      document.getElementById('hArmhole').classList.add('err');
      document.getElementById('wNeckRaglan').classList.add('err');
    }
    if (d['wBust'] <= d['wCrossback']) {
        errorTpl.push(lex['pj.wBust_wCrossback_raglan_err']);
        document.getElementById('wBust').classList.add('err');
        document.getElementById('wCrossback').classList.add('err');
    }
    if (d['hArmhole'] - (d['wRaglanSleeve'] / 2) <= (d['wCrossback'] - d['wNeck']) / 2) {
      errorTpl.push(lex['pj.hArmhole_wRaglanSleeve_err']);
      document.getElementById('hArmhole').classList.add('err');
      document.getElementById('wRaglanSleeve').classList.add('err');
      document.getElementById('wCrossback').classList.add('err');
      document.getElementById('wNeck').classList.add('err');
    }
    if (d['wNeck'] >= d['wBust'] || d['wNeck'] >= d['wCrossback']) {
      errorTpl.push(lex['pj.wNeck_wCrossback_err']);
      document.getElementById('wNeck').classList.add('err');
      document.getElementById('wBust').classList.add('err');
      document.getElementById('wCrossback').classList.add('err');
    }
    if (d['wRaglanSleeve'] >= d['wUpperarm']) {
      errorTpl.push(lex['pj.wRaglanSleeve_wUpperarm_err']);
      document.getElementById('wRaglanSleeve').classList.add('err');
      document.getElementById('wUpperarm').classList.add('err');
    }
    if (d['hNeckFront'] <= d['wRaglanSleeve'] / 2) {
      errorTpl.push(lex['pj.hNeckFront_wRaglanSleeve_err']);
      document.getElementById('hNeckFront').classList.add('err');
      document.getElementById('wRaglanSleeve').classList.add('err');
    }
    //if () {}
    //if () {}
  }
  if (shapeArm == "armCap") {
    if (d['wArmhole'] * 2 >= d['wUpperarm']){
      errorTpl.push(lex['pj.wArmhole_wUpperarm_err']);
      document.getElementById('wArmhole').classList.add('err');
      document.getElementById('wUpperarm').classList.add('err');
    }
    if (d['hArmhole'] * 2 < d['wUpperarm']) {
      errorTpl.push(lex['pj.hArmhole_wUpperarm_err']);
      document.getElementById('hArmhole').classList.add('err');
      document.getElementById('wUpperarm').classList.add('err');
    }
    if (d['hArmhole'] < d['hCap']) {
        errorTpl.push(lex['pj.hArmhole_hCap_err']);
        document.getElementById('hArmhole').classList.add('err');
        document.getElementById('hCap').classList.add('err');
    }

  }
  if (errorTpl.length > 0) {
    var errorTplNew = [...new Set(errorTpl)];
    //console.log(errorTplNew.join(""));
    document.querySelector('#alert_err').innerHTML = errorTplNew.join("");
    document.querySelector('#alert_div').classList.remove('d-none');
    document.querySelector('#alert_div').classList.add('show');
  } else {
    document.querySelector('#alert_err').innerHTML = '';
    document.querySelector('#alert_div').classList.add('d-none');
    document.querySelector('#alert_div').classList.remove('show');
  }
// ALERT: Die Breite vom Vorderteil muss noch gecheckt werden
  /**
   * ALERT: Hier noch die Breite der Blende überprüfen??
   *
   */
  /*
if (shapeFrontDivided) {
  if (shapeCut == "cutEven" && ) {}
  if (shapeCut == "cutWaistshape") {}
}

if () {}
d[''] !== d[''] d['']
*/
//  return errorTpl;
}
/** END helper functions for field manipulation **/

/** BEGIN helper functions for pattern calculation **/
/** calc quantity from len with gauge to sts/rows **/
function Gauge(gauge_len, gauge_qty, len) {
  this.len = len || 0;
  this.qty = Math.round(gauge_qty/gauge_len*len) - Math.round(gauge_qty/gauge_len*len) % 2;

}
/** Distribute decreases and increases in rows **/
function DistributeDifference(sts, rows, gap, even){
    gap ? sts++ : sts*1;
    even ? even=even*2 : even=1;
    fields = {};
    fields[1] = {};
    fields[2] = {};
    var r2m = rows - even * sts;
    switch (true) {
        case (r2m < 0):
            fields[1].rows = even;
            fields[2].rows = even;
            fields[1].sts = Math.floor(sts * even / rows);
            fields[2].sts = fields[1].sts + 1
            fields[1].qty = Math.floor(rows/even-sts+(rows/even)*(fields[1].sts))
            fields[2].qty = Math.floor(sts-(rows/even)*(fields[1].sts))
            if (this.g) {if(fields[1].qty>0) { fields[1].qty--; sts--;} else if (fields[2].qty>0) { fields[2].qty--;sts--;}};
            (even == 2) ? even = 1 : even = 0;
            break;
        case (r2m == 0):
            fields[1].qty = sts;
            fields[2].qty = 0;
            fields[1].sts = 1;
            fields[2].sts = 0;
            fields[1].rows = rows/sts;
            fields[2].rows = 0;
            if (gap) {if(fields[1].qty>0) { fields[1].qty--;sts--;} else if (fields[2].qty>0) { fields[2].qty--;sts--;}};
            (even == 2) ? even = 1 : even = 0;
            break;
        case (r2m > 0):
            fields[1].sts = 1
            fields[2].sts = 1
            fields[1].rows = Math.floor((rows/sts)/even)*even
            fields[2].rows = fields[1].rows + even
            fields[2].qty = Math.floor((rows-sts*fields[1].rows)/even)
            fields[1].qty = Math.floor(sts-rows/even+sts/even*fields[1].rows)
            if (gap) {if(fields[1].qty>0) { fields[1].qty--;sts--;} else if (fields[2].qty>0) { fields[2].qty--;sts--;}};
            (even == 2) ? even = 1 : even = 0;
            break;
        default:
            break;
    }
    this.rt = fields;
}
/** round decrease distributed in stages **/
function FiveSteps (qty_w,cap) {
    this.qty_w        = qty_w       || 0;
    this.capCap        = cap        || 0;
    var calcSteps      = [];
    if (cap) {
    var calcSteps      = { "1":{step:5, div:2},
                            "2":{step:4, div:1},
                            "3":{step:3, div:1},
                            "4":{step:2, div:1}};
    } else {
    var calcSteps      = { "1":{step:5, div:3},
                            "2":{step:4, div:3},
                            "3":{step:3, div:2},
                            "4":{step:2, div:2},
                            "5":{step:1, div:1}};
    }
    var sumRows = 0;
    var sumSts = 0;
    var sumCap = {};
    sumCap.rows = 0;
    sumCap.sts = 0;
    var rest = this.qty_w;
    var arcCal = new Object();
    var capCal = new Object();
    for(var i of Object.keys(calcSteps)) {
        var sc = new Object();
        var step = calcSteps[i];
        sc.stsRes = Math.floor(rest / step['div']);
        sc.qat = Math.floor(sc.stsRes / step['step']);
        sc.row = sc.qat * 2;
        sc.sts = step['step'];
        sumSts = sumSts + (sc.sts * sc.qat);
        sumRows = sumRows + sc.row;
        if (i == "4") {
            sumCap.rows = sumCap.rows + sumRows;
            sumCap.sts = sumCap.sts + sumSts;
        }
        arcCal[i] = sc;
        if (i!=="5"){
            capCal[i] = sc;
        }
        rest = rest - (step['step'] * sc.qat);
    }
    this.stepResult = Object.assign({}, arcCal);
    this.capResult = Object.assign({}, capCal);
    this.qty_h = sumRows;
    this.cap = sumCap;
}
/**
 * gather values and clean object fields
 * @return array
 */
function gatherVal(v) {
    var allFlds = {};
    for (let i in v) {
        allFlds[i] = v[i];
    }
// remove object and tpl fields
    for (let i in allFlds) {
        if ((typeof allFlds[i]) == 'object'){
            allFlds[i] = '';
        }
        if (allFlds[i] == '' || typeof allFlds[i] == 'undefined'){
            delete allFlds[i];
        }
    }
    return allFlds;
}
/**
 * Get the Values of all FormFields and convert to number
 * @access public
 * @return array
 */
function getValues(flds) {
  let v = [];
  for(var fld of flds) {
    switch (fld.type) {
      case "checkbox":
        fld.checked ? v [fld.id] = 1 : v [fld.id] = 0;
        break;
      case "number":
        v [fld.id] = fld.value * 1;
        break;
      default:
        v [fld.id] = (fld.id.includes("_len")) ? fld.value * 1 : v [fld.id] = fld.value;
        break;
    }
  }
  return v;
}
/**
 * replace placeholder in lexiconstring with values from result array
 * @return string
 */
function getGaugeResult(lexiconstring, results){
    text = lexiconstring;
    //console.log(lexiconstring, text);
    JSON.parse(results, (key, value) => {
        text = text.replaceAll("{"+key+"}",value);
    });
    return text;
}
/**
 * fill result of DistributeDifference() in new item of value array
 */
function fillInnerTpl(sts, rows, gap, even, innerName) {
  var text = '', innerTpl = lex["pj.innerTpl"];
  fields = new DistributeDifference(sts, rows, gap, even);
  for (var rslt of Object.keys(fields.rt)) {
        resjson = JSON.stringify(fields.rt[rslt]);
        if (fields.rt[rslt].qty !== 0) {
            text = text+getGaugeResult(innerTpl,resjson)+', ';
        }
    }
    text = text.slice(0, text.length-2);
    if (fields.rt[1].qty>0) {
      v[innerName+'_gap_rows'] = fields.rt[1].rows;
    } else if (fields.rt[2].qty>0) {
      v[innerName+'_gap_rows'] = fields.rt[2].rows;
    }
    v[innerName] = text;
    //console.log(innerName, text);
}
/**
 * fill result of FiveSteps() in new item of value array
 * @return object
 */
function fillFiveStepsTpl(qty_w,cap, capResult, innerName) {
  var text = '', innerTpl = lex["pj.innerTpl_FiveSteps"];
  fields = new FiveSteps (qty_w, cap);
  if (capResult) {
    for (var rslt of Object.keys(fields.capResult)) {
      resjson = JSON.stringify(fields.capResult[rslt]);
      if (fields.capResult[rslt].qat!==0) {
          text = text+getGaugeResult(innerTpl,resjson)+', ';
      }
    }
  } else {
    for (var rslt of Object.keys(fields.stepResult)) {
      resjson = JSON.stringify(fields.stepResult[rslt]);
      if (fields.stepResult[rslt].qat!==0) {
          text = text+getGaugeResult(innerTpl,resjson)+', ';
      }
    }
  }
  text = text.slice(0, text.length-2);
  v[innerName] = text;
  return fields;
  //console.log(innerName, text);
}
/** END helper functions for pattern calculation **/

/** BEGIN functions for pattern calculation **/
/**
 * function linked to Modal editPjModal
 */
function updateProject() {
  // Hier müssen die Felder im Formular geändert werden und der Wert in den inputs gespeichert
  document.querySelector('#description_target').innerHTML = document.querySelector('#description').value;
  document.querySelector('#title_target').innerHTML = document.querySelector('#title').value;
}
/**
 * calculate pattern, fill result in placeholder and hide/show parts of pattern
 */
function writePattern() {
  // Jetzt wird die Anleitung erstellt.
console.log("pattern START");
  var tplCastonBack = (shapeCut == "cutEven") ? lex["pj.caston_back_" + shapeCut + "_" + Math.floor(shapeHasSleeve) + "_tpl"] : lex["pj.caston_back_" + shapeCut + "_tpl"]
  var tplCastonSleeve = lex["pj.castonSleeve_tpl"], tplBiasSleeve = lex["pj.biasSleeve_tpl"];
  var tplShoulder = (shapeShoulder == "") ? "" :lex["pj.shoulder_" + shapeShoulder + "_tpl"];
  var tplRaglanYoke = (shapeArm == "armRaglan") ? lex["pj.raglan_" + shapeRaglan + "_tpl"] : ' ';
  var tplArmhole = (shapeArm == "armRaglan" && shapeRaglan == "raglanRow") ? lex["pj.armhole_" + shapeArm + "_" + shapeRaglan + "_tpl"] : lex["pj.armhole_" + shapeArm + "_tpl"];
  tplArmhole = (shapeArm == "armEven" && shapeCut == "cutEven") ? lex["pj.armhole_" + shapeArm + "_" + Math.floor(shapeHasSleeve) + "_tpl"] : lex["pj.armhole_" + shapeArm + "_tpl"];
  var tplNeckBack = (shapeArm == "armRaglan") ? lex["pj.neckBack_" + shapeRaglan + "_tpl"] : lex["pj.neckBack_tpl"];
  var tplArmCap = (shapeArm == "armRaglan" && shapeRaglan == "raglanRow") ? lex["pj.cap_" + shapeArm + "_" + shapeRaglan + "_tpl"] : lex["pj.cap_" + shapeArm + "_tpl"];
  v = getValues(flds);
  var tplCastonFront = (shapeArm == "armRaglan" && shapeRaglan == "raglanRound") ? lex["pj.caston_front_" + Math.floor(shapeFrontDivided) + "_" + shapeRaglan + "_tpl"] : lex["pj.caston_front_" + Math.floor(shapeFrontDivided) + "_tpl"];
  var tplNeckFront = lex["pj.neck_" + shapeNeck + "_front_" + Math.floor(shapeFrontDivided) + "_tpl"];
  var tplRaglanTable = (shapeArm == "armRaglan" && shapeRaglan !== "raglanRow") ? lex["pj.raglan_" + shapeRaglan + "_table_tpl"] : ' ';
  // calc all dims with gauge
  for (var i = 0; i < res.dims.length; i++) {
    var qty = new Gauge(v["len_"+v[res.dims[i]+"_dtn_d"]] ,v["qty_"+v[res.dims[i]+"_dtn_d"]],v[res.dims[i]+"_len"]);
    v[res.dims[i]+"_qty"] = qty.qty;
  }
  // Change total number of sts based on starting values
  v.wCrossback_qty = v.wBust_qty - v.wArmhole_qty * 2;
  v.wNeck_qty = (shapeArm !== "armEven") ?  v.wCrossback_qty - v.wShoulder_qty * 2 : v.wNeck_qty;
  v.wWaist_qty = v.wHips_qty - Math.round((v.wHips_qty - v.wWaist_qty)/2) * 2;
  v.wBust_qty = v.wWaist_qty + Math.round((v.wBust_qty - v.wWaist_qty)/2) * 2;
  v.wBust_qty = v.wHips_qty - Math.round((v.wHips_qty - v.wBust_qty)/2) * 2;
  v.wBust_qty = (shapeArm == "armEven") ? v.wNeck_qty + v.wShoulder_qty * 2 : v.wBust_qty;
  // Change total number of rows based on starting values
  v.hCo2Armhole_qty = (shapeCut == "cutWaistshape") ? v.hCo2hips_qty + v.hHips2waist_qty + v.hWaist2armhole_qty : v.hCo2Armhole_qty;
  v.hProject_qty = (v.hCo2Armhole_qty > 0 && v.hArmhole_qty > 0) ? v.hCo2Armhole_qty + v.hArmhole_qty : v.hProject_qty;
  v.hSleeve_qty = v.hCap_qty + v.hSleeve2Underarm_qty;
  // default values for inner_tpl to prevent bad values
  v.cutWaistshape_dec = ' - ';
  v.cutWaistshape_dec_gap_rows = ' - ';
  v.cutWaistshape_inc = ' - ';
  v.cutWaistshape_inc_gap_rows = ' - ';
  v.cutAline_dec = ' - ';
  v.cutAline_dec_gap_rows = ' - ';
  v.cutSingleshape_inc = ' - ';
  v.cutSingleshape_inc_gap_rows = ' - ';
// shape from castOn to armhole
  fillInnerTpl(Math.round((v.wHips_qty - v.wWaist_qty)/2), (v.hHips2waist_qty), 1, 1, "cutWaistshape_dec");
  fillInnerTpl(Math.round((v.wBust_qty - v.wWaist_qty)/2), (v.hWaist2armhole_qty), 1, 1, "cutWaistshape_inc");
  fillInnerTpl(Math.round((v.wHips_qty - v.wBust_qty)/2), (v.hCo2Armhole_qty - v.hCo2hips_qty), 1, 1, "cutAline_dec");
  fillInnerTpl((v.wBust_qty - v.wWaist_qty)/2, v.hCo2Armhole_qty, 1, 1,"cutSingleshape_inc");

  v.frontband_tpl = lex["pj.caston_frontband_" + v.frontband + "_tpl"];
  v.frontblend_wide = (v.frontband) ? v.wFrontband_len + lex["pj.len_tpl"] : v.wFrontband_qty + lex["pj.wqty_tpl"];
/*  if (v.frontband) {
    v.frontblend_wide = v.wFrontband_len + lex["pj.len_tpl"];
  } else {
    v.frontblend_wide = v.wFrontband_qty + lex["pj.wqty_tpl"];
  }
*/
  // armCap
  v.armCap = fillFiveStepsTpl(v.wArmhole_qty,0,0, "armhole_armCap_dec");
  // 1/3 upperarm
  v.wCap_bindoff = Math.round(v.wUpperarm_qty/6) + Math.abs(v.wUpperarm_qty % 2);
  v.capTop = fillFiveStepsTpl(Math.round(v.wUpperarm_qty/12), 1, 0, "capTop_dec");
  v.capStart = fillFiveStepsTpl(v.wArmhole_qty,0, 1,"capStart_dec");
  v.capRestRows = v.hCap_qty - 2 - v.capStart.cap.rows - v.capTop.cap.rows;
  v.capRestSts = v.wUpperarm_qty - v.capStart.cap.sts * 2 - v.capTop.cap.sts * 2 - v.wCap_bindoff;
  v.wCap_bindoff = v.wCap_bindoff + Math.abs(v.capRestSts % 2);
  fillInnerTpl(Math.floor(v.capRestSts)/2, v.capRestRows, 1, 1,"capMid_dec");
// ALERT: die Reihen stimmen noch nicht
  // armEvenSi / armSlope: only existing values
  v.wArmhole_bindoff = Math.round(v.wArmhole_qty / 3);
  v.wArmhole_dec = v.wArmhole_qty - v.wArmhole_bindoff;
  // armRaglan
  v.wArmpit_qty = (Math.floor((v.wBust_qty - v.wCrossback_qty) / 8) <= 3) ?  3 : Math.floor((v.wBust_qty - v.wCrossback_qty) / 8);
  v.wBust_qty_yoke = v.wBust_qty - v.wArmpit_qty * 2;
  v.wUpperarm_qty_yoke = v.wUpperarm_qty - v.wArmpit_qty * 2;
  v.sumYoke = (v.wBust_qty_yoke + v.wUpperarm_qty_yoke) * 2;
  // if raglanRow RL = 0;
  v.wRaglanLine_qty = (shapeArm == "armRaglan" && shapeRaglan == "raglanRow") ? 0 : v.wRaglanLine_qty;
  v.wBust_qty_RL = v.wBust_qty_yoke - v.wRaglanLine_qty;
  v.wUpperarm_qty_RL = v.wUpperarm_qty_yoke - v.wRaglanLine_qty;
  v.wNeckRaglan_qty_RL = v.wNeckRaglan_qty - v.wRaglanLine_qty;
  v.wNeck_qty_RL = v.wNeck_qty - v.wRaglanLine_qty;
  fillInnerTpl(Math.floor((v.wBust_qty_RL - v.wNeck_qty) / 2), (v.hCap_qty-2), 0, 1, "armRaglan_back_dec");
  fillInnerTpl(Math.floor((v.wUpperarm_qty_RL - v.wNeckRaglan_qty) / 2), (v.hCap_qty-2), 0, 1, "armRaglan_sleeve_dec");
  // fill table  for Raglan
  var Row_text = '';
  var tVal = {};
  // 2 stitches less for the first dec of beginning of armhole
  if (shapeArm == "armRaglan" && shapeRaglan == "raglanRound") {
      tVal.sts_back = v.wBust_qty_RL - 2;
      tVal.sts_arm = v.wUpperarm_qty_RL - 2;
  } else {
      tVal.sts_back = v.wNeck_qty_RL - 2;
      tVal.sts_arm = v.wArm_qty_RL - 2;
  }
  tVal.RL_qty = v.wRaglanLine_qty;
  v.Back_dec = new DistributeDifference(Math.floor((v.wBust_qty_RL - v.wNeck_qty) / 2), (v.hCap_qty-2), 0, 1);
  v.Arm_dec = new DistributeDifference(Math.floor((v.wUpperarm_qty_RL - v.wNeckRaglan_qty) / 2), (v.hCap_qty-2), 0, 1);
// calculate and fill table with dec/ind of raglanYoke
  for (let i = 1; i <= (v.hCap_qty / 2); i++) {
    tVal.rowNum = i*2;
    if (i <= v.Back_dec.rt[1].qty) {
      tVal.back_sts_dec = v.Back_dec.rt[1].sts
      tVal.back_sts_next = v.Back_dec.rt[1].sts * 2
      tVal.nextRowBack = tVal.rowNum + v.Back_dec.rt[1].rows
    } else {
      if (tVal.rowNum == tVal.nextRowBack) {
        tVal.back_sts_dec = v.Back_dec.rt[2].sts
        tVal.back_sts_next = v.Back_dec.rt[2].sts * 2
        tVal.nextRowBack = tVal.rowNum + v.Back_dec.rt[2].rows
      } else {
        tVal.back_sts_dec = 0;
        tVal.back_sts_next = 0;
      }
    }
    if (i <= v.Arm_dec.rt[1].qty) {
      tVal.arm_sts_dec = v.Arm_dec.rt[1].sts
      tVal.arm_sts_next = v.Arm_dec.rt[1].sts * 2
      tVal.nextRowArm = tVal.rowNum + v.Arm_dec.rt[1].rows
    } else {
      if (tVal.rowNum == tVal.nextRowArm) {
        tVal.arm_sts_dec = v.Arm_dec.rt[2].sts
        tVal.arm_sts_next = v.Arm_dec.rt[2].sts * 2
        tVal.nextRowArm = tVal.rowNum + v.Arm_dec.rt[2].rows
      } else {
        tVal.arm_sts_dec = 0;
        tVal.arm_sts_next = 0;
      }
    }
    tVal.dec = 8;
    if (shapeArm == "armRaglan" && shapeRaglan == "raglanRound") {
        tVal.sts_back = tVal.sts_back - tVal.back_sts_next;
        tVal.sts_arm = tVal.sts_arm - tVal.arm_sts_next;
    } else {
        tVal.sts_back = tVal.sts_back + tVal.back_sts_next;
        tVal.sts_arm = tVal.sts_arm + tVal.arm_sts_next;
    }

    tVal.sts_sum = tVal.sts_back*2 + tVal.sts_arm*2 + tVal.RL_qty*4 + tVal.dec;
    tValjson = JSON.stringify(tVal);
    Row_text = Row_text+getGaugeResult(tplRaglanTable,tValjson);
    //console.log(Row_text);
  }
  v.row_line_content = Row_text;
  // armEven: only existing values
  // armYoke: disabled to next version
  // shoulderSlope
  fillInnerTpl(v.wShoulder_qty, v.hShoulder_qty, 0, 1,"shoulder_dec");
  // shoulderEven
  if (shapeShoulder == "shoulderSlope" && shapeArm !== "armRaglan") {
    v.hArmhole_qty = v.hArmhole_qty - v.hShoulder_qty;
  }
  // neckBack
  v.neckBack_start_len = v.hProject_len - v.hNeckBack_len;
  v.neckBack_start_qty = v.hProject_qty - v.hNeckBack_qty;
  v.neckBack_dec = (v.hNeckBack_qty - 2) / 2;
  v.neckBack_bindoff = v.wNeck_qty - 2 * v.neckBack_dec;
  // neckFront
  v.neckFront_start_len = v.hProject_len - v.hNeckFront_len;
  v.neckFront_start_qty = v.hProject_qty - v.hNeckFront_qty;
  // neckRound
  v.neckFront_centerBindOff = Math.round(v.wNeck_qty /3);
  v.neckFront_side = Math.round((v.wNeck_qty - v.neckFront_centerBindOff)/2);
  v.neckFront_centerBindOff = (v.wNeck_qty - (v.neckFront_side*2));
  if (v.front_divided) {
    if (v.frontband) {
      v.neckFront_centerBindOff = v.neckFront_centerBindOff - v.wFrontband_qty;
      v.neck_center_frontband = ' ';
    } else {
      // keine Ahnung
      v.neck_center_frontband = lex["pj.neck_center_frontband_tpl"];
    }
  }
  fillFiveStepsTpl(v.neckFront_side,0,0, "neckRound_dec");
  //neck_center_frontband
  // neckV
  // armRaglan ? hNeckFront_qty - wRaglanSleeve_qty
  if (shapeArm == "armRaglan") {
    fillInnerTpl(v.wNeck_qty/2, v.hNeckFront_qty-(v.hArmhole_qty - v.hCap_qty), 1, 1,"neckV_dec");
  } else {
    fillInnerTpl(v.wNeck_qty/2, v.hNeckFront_qty, 1, 1,"neckV_dec");
  }
  // biasSleeve
  fillInnerTpl(Math.round((v.wUpperarm_qty - v.wWrist_qty) /2), v.hSleeve2Underarm_qty, 1, 1,"biasSleeve_inc");
  //Arm cap
  // ALERT: Das stimmt hier alles nocht nicht. Die Abnahmen an der Armkugel müssen gleich sein wie am Armloch und
  // ich brauche dann die Höhe der restlichen Reihen und Maschen. Das heißt ich muss die Zwischenergebnisse auch speichern und überprüfen

  v.pattern_meta = JSON.stringify(gatherVal(v));
  v.castonBack = getGaugeResult(tplCastonBack,v.pattern_meta);
  v.armhole = getGaugeResult(tplArmhole,v.pattern_meta);
  v.neckBack = getGaugeResult(tplNeckBack,v.pattern_meta);
  document.getElementById('neckBackShow').hidden = (shapeArm == "armRaglan" && shapeRaglan == "raglanRound") ? true : false;
  v.shoulderLine = getGaugeResult(tplShoulder,v.pattern_meta);
  document.getElementById('shoulderShow').hidden = (shapeArm == "armRaglan" ) ? true : false;
  //&& shapeRaglan !== "raglanRow"
  v.castonFront = getGaugeResult(tplCastonFront,v.pattern_meta);
  v.neckFront = getGaugeResult(tplNeckFront,v.pattern_meta);
  document.getElementById('neckFrontShow').hidden = (shapeArm == "armRaglan" && shapeRaglan == "raglanRound") ? true : false;
  v.castonSleeve = getGaugeResult(tplCastonSleeve,v.pattern_meta);
  v.biasSleeve = getGaugeResult(tplBiasSleeve,v.pattern_meta);
  v.capSleeve = getGaugeResult(tplArmCap,v.pattern_meta);
  document.getElementById('capSleeveShow').hidden = (shapeArm == "armRaglan" && shapeRaglan == "raglanRound") ? true : false;

  // Raglan
  v.raglanYoke = getGaugeResult(tplRaglanYoke,v.pattern_meta);
  document.getElementById('raglanRoundShow').hidden = (shapeArm == "armRaglan" && shapeRaglan == "raglanRound") ? false : true;
  v.shoulderLine = getGaugeResult(tplShoulder,v.pattern_meta);
  v.tblRaglanRound = v.row_line_content;
  v.pattern_meta = JSON.stringify(gatherVal(v));
    for(var fld of flds) {
        fld.value = v[fld.id];
    }
  var resultPs = document.querySelectorAll('.resultP');
  for(var resultP of resultPs){
    resultP.innerHTML = v[resultP.id];
  }
console.log("pattern END");
  return true;
}
/**
 * show and hide iPrint/iWeb span
 */
function prtPattern() {
  var kaVal = getKnitApp();
  var darkThemeSelected = (kaVal !== null && kaVal.theme === 'dark');
  if (document.getElementById('iPrint').hidden) {
      if (darkThemeSelected) {
          document.documentElement.dataset.bsTheme = 'dark';
      }
      document.body.classList.remove('print');
      document.getElementById('iPrint').hidden = false;
      document.getElementById('iWeb').hidden = true;
      //setShapes();
      var sk1 = document.getElementById('cut_sketch');
      var sk2 = document.getElementById('sleeve_sketch');
      sk1.getElementsByTagName("g").forEach(function(el) {
        if (el.getAttributeNS("http://www.w3.org/2000/svg", 'data-bs-target') == '#dim-modal') {
          var gg = document.createElementNS("http://www.w3.org/2000/svg","a");
            for (const n of el.getAttributeNames()) {
              gg.setAttribute( n, el.getAttributeNS("http://www.w3.org/2000/svg", n));
            }
          gg.innerHTML = el.innerHTML;
          el.replaceWith(gg);
        }
      });
      sk2.getElementsByTagName("g").forEach(function(el) {
        if (el.getAttributeNS("http://www.w3.org/2000/svg", 'data-bs-target') == '#dim-modal') {
          var gg = document.createElementNS("http://www.w3.org/2000/svg","a");
            for (const n of el.getAttributeNames()) {
              gg.setAttribute( n, el.getAttributeNS("http://www.w3.org/2000/svg", n));
            }
          gg.innerHTML = el.innerHTML;
          el.replaceWith(gg);
        }
      });
  } else {
      if (darkThemeSelected) {
        document.documentElement.dataset.bsTheme = 'light';
      }
      var shapeText = lex["pj.shapeprt_" + shapeCut] + lex["pj.shapeprt_" + Math.floor(shapeHasSleeve)+Math.floor(shapeFrontDivided)] + lex["pj.shapeprt_" + shapeNeck] + lex["pj.shapeprt_" + shapeShoulder] + lex["pj.shapeprt_" + shapeArm];
      shapeText += (shapeArm == "armRaglan") ? lex["pj.shapeprt_" + shapeRaglan] : '';
      document.getElementById('shape_prt_value').innerHTML = shapeText;
      document.body.classList.add('print');
      document.getElementById('iPrint').hidden = true;
      document.getElementById('iWeb').hidden = false;
      Array.from(document.querySelectorAll("[data-bs-target='#dim-modal']")).forEach(function(el) {
        var gg = document.createElementNS("http://www.w3.org/2000/svg","g");
        for (const n of el.getAttributeNames()) {
          gg.setAttributeNS("http://www.w3.org/2000/svg", n, el.getAttribute(n));
        }
        gg.innerHTML = el.innerHTML;
        el.replaceWith(gg);
      });
      var printcalc = document.getElementById('prt-'+res.alias);
      var opt = {
          margin: 10,
          filename: 'JustKnit-'+res.alias+'.pdf',
          image: {type: 'jpeg', quality: 1},
          enableLinks: 1,
          html2canvas: {
              scale: 1.5,
              dpi: 72,
              letterRendering: true
          },
          html2canvas: {
              onclone: (printcalc) => {
                  const svgElements = Array.from(printcalc.querySelectorAll('svg'));
                  svgElements.forEach(s => {
                      const bBox = s.getBBox();
                      s.setAttribute("x", bBox.x);
                      s.setAttribute("y", bBox.y);
                      s.setAttribute("width", bBox.width);
                      s.setAttribute("height", bBox.height);
                  })
              }
          }
      };
      html2pdf().set({
        pagebreak: { mode: ['avoid-all', 'css', 'legacy'], before: '.printBefore', after: '.printAfter', avoid: 'svg' }
      });
      html2pdf().set(opt).from(printcalc).toPdf().save();
  }
}
/** END functions for pattern calculation **/
